#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <semaphore.h>
#include <fcntl.h>
#include <sys/mman.h>

#define BUFFER_SIZE 5
#define SHMOBJ_PATH	"/tmp"
 
typedef struct
{
	int buffer[BUFFER_SIZE]; //futoszalag
	sem_t ures;	//üres helyek számát jelző szemafor. kezdetben: BUFFER_SIZE
	sem_t tele;	//tele helyek számát jelző szemafor. kezdetben: 0.
	sem_t pmut;	//termelők mutex-e. Biztosítja, hogy egyszerre csak egy folyamat termeljen.
	sem_t cmut;	//fogyasztók mutex-e. Biztosítja, hogy egyszerre csak egy folyamat fogyasszon.
	int nextin;	//következő termelt adat helye
	int nextout;	//következő elfogyasztani kívánt adat pozíciója

} osztottMemoriaTipus;

 
int lekerOsztottMemoriaID()
{
	int shmfd = shm_open(SHMOBJ_PATH, O_RDWR, S_IRWXU | S_IRWXG);
  	//ha már van ilyen key kulcsú szemafor létrehozva
  	if (shmfd == -1){
    		shmfd = shm_open(SHMOBJ_PATH, O_CREAT | O_EXCL | O_RDWR, S_IRWXU | S_IRWXG);
    		if (shmfd < 0) {
    			perror("In shm_open()");
        		exit(1);
    		}
		
		/* adjusting mapped file size (make room for the whole segment to map) --  ftruncate() */
		ftruncate(shmfd, sizeof(osztottMemoriaTipus));
	}
  return shmfd;
}

void initSzemaforok(osztottMemoriaTipus* p)
{
	if(sem_init(&(p->ures),1,BUFFER_SIZE) < 0 ){
		perror("In sem_init()");
		exit(1);	
	}
	if(sem_init(&(p->tele),1,0) < 0){
		perror("In sem_init()");
		exit(1);
	}
	if(sem_init(&(p->pmut),1,1) < 0){
		perror("In sem_init()");
		exit(1);
	}
	if(sem_init(&(p->cmut),1,1) < 0){
		perror("In sem_init()");
		exit(1);
	}
	p->nextin = p->nextout = 0;
}
