#include "header.h"

void initOsztottMemoria(osztottMemoriaTipus* p)
{
	//lenullázzuk a puffert (leürítjük a futószalagot)
	int i = 0;

	for(i=0; i< BUFFER_SIZE; ++i){
		p->buffer[i] = 0; 
	}
}
 
void termel(osztottMemoriaTipus* p)
{
	//a termelo elkezdi pakolni a termekeket a futoszalagra
	int item = -1;

	sem_wait(&(p->ures));
	sem_wait(&(p->pmut));

	item = rand()%10 + 1;
	printf("%d\n",item);
	p->buffer[p->nextin] = item;
	p->nextin++;
	p->nextin %= BUFFER_SIZE;
 
	sem_post(&(p->pmut));
	sem_post(&(p->tele));
}
 

int main()
{
	int shmfd = lekerOsztottMemoriaID();
	int t;
	srand(getpid());
	osztottMemoriaTipus * p;
	int shared_seg_size = sizeof(osztottMemoriaTipus);
	/* requesting the shared segment --  mmap() */    
	p = (osztottMemoriaTipus *)mmap(NULL, shared_seg_size, PROT_READ | PROT_WRITE, MAP_SHARED, shmfd, 0);
	if (p == NULL) {
		perror("In mmap()");
	        exit(1);
	}
	initOsztottMemoria(p);
	initSzemaforok(p);

	for(t=0; t<20; t++){
		termel(p);
	}

	return 0;
}
